//+------------------------------------------------------------------+
//|                                                     MProfile.mq4 |
//|                                  Copyright  2005, Yuri Makarov. |
//|                                       http://mak.tradersmind.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Yuri Makarov."
#property link      "http://mak.tradersmind.com"
#property indicator_separate_window
#property indicator_color1  DarkTurquoise
#property indicator_buffers 1
#property indicator_minimum 0
extern int Length = 200;
extern int Smooth = 2;
double Profile[];
double MinV;
double MaxV;
string short_name;
int prevDate = 0;
int start()
{
   if (prevDate != Time[0])
   {
      NewBar();
      prevDate = Time[0];
   }
   int kPrice = Length * (Close[0] - MinV) / (MaxV - MinV);
   ObjectSet("CurentPrice", OBJPROP_TIME1, Time[Length - kPrice]);
}
void NewBar()
{
   CalcProfile();
}
void CalcProfile()
{
   int i;
   int Width = Length;
   
   MinV = Low[0];
   MaxV = High[0];
   for (i = 1; i < Length; i++)
   {
      if (MinV > Low[i] && Low[i] > 0) MinV = Low[i];
      if (MaxV < High[i]&& High[i]> 0) MaxV = High[i];
   }
   for (i = 0; i < Bars; i++) Profile[i] = 0;
   if (MaxV - MinV > 0)
   {
      for (i = 0; i < Length; i++) 
      {
         int kStart = Width * (Low[i]  - MinV) / (MaxV - MinV);
         int kStop  = Width * (High[i] - MinV) / (MaxV - MinV);
         for (int j = kStart; j <= kStop; j++)
            if (j >= 0) Profile[Width - j]++;
      }
      double F = 2. / (Smooth + 1);
      Print(F);
      for (i = 1; i < Width; i++) 
         Profile[i] = Profile[i-1] + (Profile[i] - Profile[i-1])*F;
      for (i = Width; i > 0; i--) 
      {
         Profile[i-1] = Profile[i] + (Profile[i-1] - Profile[i])*F;
      }
   }
   
   ObjectSet("MarginLeft",  OBJPROP_TIME1, Time[Width+1]);
   ObjectSet("MarginRight", OBJPROP_TIME1, Time[0]);
}
int init()
{
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(0, Profile);
   short_name = "Profile(" + Length + ")";
   IndicatorShortName(short_name);
   SetIndexLabel(0, short_name);
   
   ObjectCreate("MarginLeft", OBJ_VLINE,0,Time[Length+1],0);
   ObjectCreate("MarginRight",OBJ_VLINE,0,Time[0],0);
   ObjectCreate("CurentPrice",OBJ_VLINE,0,Time[0],0);
   ObjectSet("CurentPrice",OBJPROP_WIDTH,2);
   ObjectSet("CurentPrice",OBJPROP_COLOR,MediumBlue);
   
   for (int i = 0; i < Bars; i++) Profile[i] = 0;
   NewBar();
}
int deinit()
{
   ObjectDelete("MarginLeft");
   ObjectDelete("MarginRight");
}

